﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;

namespace ftpupload
{
    public class fileupload : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            try
            {
                string halfpath = "Uploads/";//path for ftpupload
                string str_image = "";
                long ticks = DateTime.Now.Ticks; //using date creating unique file.
                foreach (string s in context.Request.Files)//here we can upload single/multiple files at a time. 
                {
                    HttpPostedFile file = context.Request.Files[s];
                    string fileName = file.FileName;
                    string fileExtension = file.ContentType;//get file extension

                    if (!string.IsNullOrEmpty(fileName))
                    {
                        fileExtension = Path.GetExtension(fileName);
                        str_image = "file" + ticks.ToString() + fileExtension;
                        string localpath = HttpContext.Current.Server.MapPath("~/Uploads/") + str_image;// gets full path where the file to be uploaded.
                        file.SaveAs(localpath);// this saves the file in local application directory
                        halfpath += str_image;//here it create the full file path where file should be uploaded in FTP.
                        string res = UploadFile(localpath, halfpath);// this calls the FTP UploadFile function to upload the file.
                    }
                }
                context.Response.Write(halfpath);
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }
        public bool IsReusable
        {
            get
            {
                return false;
            }
        }

        public static string UploadFile(string path, string upload_path)
        {
           
            string ip = "192.168.1.1";// please enter your ip/ftp url here
            string username = "username";//Enter your FTP user name
            string password = "password";//Enter your FTP password name

            string fullpath = "ftp://" + ip + "/" + upload_path; //with ip/url create a ftp path where you will upload

            FileInfo fileInf = new FileInfo(path);

            FtpWebRequest reqFTP;
            // Create FtpWebRequest object from the Uri provided
            reqFTP = (FtpWebRequest)FtpWebRequest.Create(fullpath);
            // Provide the WebPermission Credentials
            reqFTP.Credentials = new NetworkCredential(username, password);
            reqFTP.Proxy = null; //Set Proxy to be null
            // By default KeepAlive is true, where the control connection is not closed
            // after a command is executed.
            reqFTP.KeepAlive = false;
            // Specify the command to be executed.
            reqFTP.Method = WebRequestMethods.Ftp.UploadFile;
            // reqFTP.Method = WebRequestMethods.Ftp.ListDirectory;
            // Specify the data transfer type.
            reqFTP.UseBinary = true;
            // Notify the server about the size of the uploaded file
            reqFTP.ContentLength = fileInf.Length;
            //SSL
            reqFTP.EnableSsl = false;
            // The buffer size is set to 2kb
            int buffLength = 2048;
            byte[] buff = new byte[buffLength];
            int contentLen;

            // Stream to which the file to be upload is written
            try
            {
                Stream strm = reqFTP.GetRequestStream();
                // Opens a file stream (System.IO.FileStream) to read the file to be uploaded
                FileStream fs = fileInf.OpenRead();
                try
                {
                    do
                    {
                        contentLen = fs.Read(buff, 0, buffLength);
                        strm.Write(buff, 0, contentLen);
                    } while (contentLen != 0);
                    fs.Close();
                    strm.Close();
                }
                catch (WebException ex)
                {
                    String status = ((FtpWebResponse)ex.Response).StatusDescription;
                    return ex.ToString();
                }
            }
            catch (WebException ex)
            {
                String status = ((FtpWebResponse)ex.Response).StatusDescription;
                return ex.ToString();
            }
            //here it will delete the file from local application temp location after uploading to ftp server.
            if ((System.IO.File.Exists(path)))
            {
                System.IO.File.Delete(path);
            }
            return "1";
        }

    }
}